/*
 3 .
   ,    
*/

.include "C:\Program Files\Atmel\AVR Studio 5.0\avrassembler\include\tn13Adef.inc"


/**************************************************************************************/
/*                                                                     */
/**************************************************************************************/

.equ	c_max_gradations	=	128;	    
.equ	c_programs_count	=	6;		  

.equ	c_program_1_countdown = 128;    1 

.equ	c_random_start_value	= 1
/**************************************************************************************/
/*                                                                   */
/**************************************************************************************/

.def	brightR	= r1			;   - 0  
.def	brightG	= r2			;   - 0  
.def	brightB	= r3			;   - 0  

.def	current_programm = r4	;   
.def	current_pwm_value = r5	;    .   
.def	flag_register = r6		;0     -   
								;1    



.def	tmp1 = r16				; 
.def	tmp2 = r17				; 
.def	tmp3 = r18				; 
.def	tmp4 = r19				; 

.def	arg1 = r20				;  
.def	arg2 = r21


.def	work_timer1 = r22		;/  
.def	work_timer2 = r23
.def	work_timer3 = r24
.def	work_timer4 = r25

.def	random_number = r7		;   

.dseg
.org	0x60



/**************************************************************************************/
/*                                                                   */
/**************************************************************************************/
.cseg
.org 0
	rjmp	event_reset
	rjmp	event_button_down	; External Interrupt 0
	reti					; External Interrupt Request 0
	rjmp	event_timer		; Timer/Counter0 Overflow
	reti					; EEPROM Ready
	reti					; Analog Comparator
	reti					; Timer/Counter Compare Match A
	reti					; Timer/Counter Compare Match B
	reti					; Watchdog Time-out
	reti					; ADC Conversion Complete

/**************************************************************************************/
/*                                                              */
/**************************************************************************************/
event_reset:
	/**/
	ldi	tmp1,	RAMEND
	out	SPL,	tmp1
	
	/*  /; 2,3,4  - RGB */
	ldi		tmp1,	0<<DDB0|0<<DDB1|1<<DDB2|1<<DDB3|1<<DDB4
	out		DDRB,	tmp1
	clr		tmp1
	out		PORTB,	tmp1

	/* */
	ldi		tmp1,	1<<CS00	;    
	out		TCCR0B,	tmp1
	ldi		tmp1,	1<<TOIE0; 
	out		TIMSK0,	tmp1

	/* */

	ldi		tmp1,	1<<INT0
	out		GIMSK,	tmp1

	ldi		tmp1,	1<<ISC01||0<<ISC00
	out		MCUCR,	tmp1

	/* */
	clr		current_pwm_value
	
	/*  */
	ldi		tmp1,			c_random_start_value
	mov		random_number,	tmp1

	/* */
	clr		current_programm
	ldi		arg1,5					;  5
	clr		arg2					;
	rcall	sub_get_programm_address;    0  ZL ZH
	icall
	ldi		arg2,	1				;   0  ZL ZH
	rcall	sub_get_programm_address


	sei
/**************************************************************************************/
/*  .           */
/**************************************************************************************/
main_loop:
	sbrs	flag_register,	0		;   -    
	icall
	rjmp	main_loop


/**************************************************************************************/
/*           .        RGB             */
/**************************************************************************************/
event_timer:
	
	/*        */
	push	tmp1
	in		tmp1,	SREG
	push	tmp1
	push	tmp2
	clr		tmp1		
	
	mov		tmp2,	current_pwm_value
	/*, -      1.. 
	  -  */	
	tst		brightR
	breq	ev_t_skip_red			; 0 -  
	cp		tmp2,	brightR			;    -  
	brpl	ev_t_skip_red
	ori		tmp1,	0b00000100
ev_t_skip_red:
	tst		brightG
	breq	ev_t_skip_green
	cp		tmp2,	brightG
	brpl	ev_t_skip_green
	ori		tmp1,	0b00001000
ev_t_skip_green:
	tst		brightB
	breq	ev_t_skip_blue
	cp		tmp2,	brightB
	brpl	ev_t_skip_blue
	ori		tmp1,	0b00010000
ev_t_skip_blue:

	/* */
	out		PORTB,	tmp1

	/*  pwm*/
	inc		tmp2
	cpi		tmp2, c_max_gradations + 1
	brne	ev_t_exit
	clr		tmp2
ev_t_exit:
	mov		current_pwm_value, tmp2
	pop		tmp2
	pop		tmp1
	out		SREG,	tmp1
	pop		tmp1
	reti


/**************************************************************************************/
/*                                                         */
/**************************************************************************************/
event_button_down:
	sbis		PINB,	DDB1
	reti

	push		tmp1
	in			tmp1,	SREG
	push		tmp1
	push		tmp2
	push		arg1
	push		arg2

	clr			flag_register
	clr			tmp1
	out			PORTB,	tmp1

	/* - ,   */
	ldi			arg1,	255
	ldi			arg2,	2				
	rcall		sub_delay

ev_b_waitfor_up:
	sbic		PINB,	DDB1
	rjmp		ev_b_waitfor_up
	
	ldi			arg1,	255
	ldi			arg2,	1				
	rcall		sub_delay

	clr			tmp1
	out			PORTB,	tmp1

	/*    Pn+1 (   !)*/
	mov			tmp1,	current_programm
	inc			tmp1
	cpi			tmp1,	c_programs_count
	brlo		ev_b_skip_clear
	clr			tmp1
ev_b_skip_clear:
	mov			current_programm,	tmp1

	/*  */
	mov			arg1,	current_programm
	clr			arg2
	rcall		sub_get_programm_address;    0  ZL ZH
	icall
	ldi			arg2,	1				;   0  ZL ZH
	rcall		sub_get_programm_address

	pop			arg2
	pop			arg1
	pop			tmp2
	pop			tmp1
	out			SREG,	tmp1
	pop			tmp1	

	/*      ,       main_loop*/
	in			tmp4,	SPL
	subi		tmp4,	-2
	out			SPL,	tmp4

	sei

	rjmp		main_loop


/**************************************************************************************/
/*                                                    */
/**************************************************************************************/
sub_delay:
	
	push		tmp1
	in			tmp1,	SREG
	push		tmp1
	push		tmp2
	push		tmp3

	ldi			tmp1,	255
	mov			tmp2,	arg1
	mov			tmp3,	arg2

sb_d_loop:
	subi		tmp1,	1
	sbci		tmp2,	0
	sbci		tmp3,	0
	brcc		sb_d_loop

	pop			tmp3
	pop			tmp2
	pop			tmp1
	out			SREG,	tmp1
	pop			tmp1
	ret


/**************************************************************************************/
/*                            0.   .                           */
/**************************************************************************************/
sub_programm_0_init:
	push	tmp1
	ldi		tmp1,		c_max_gradations
	mov		brightR,	tmp1
	lsr		tmp1
	lsr		tmp1
	mov		brightG,	tmp1
	clr		tmp1
	mov		brightB,	tmp1
	pop		tmp1
	ret
sub_programm_0:
	ret

/**************************************************************************************/
/*                            1.    0                      */
/**************************************************************************************/
sub_programm_1_init:
	push	tmp1
	ldi		tmp1,			c_max_gradations
	mov		brightR,		tmp1
	mov		brightG,		tmp1
	mov		brightB,		tmp1
	ldi		work_timer1,	255
	ldi		work_timer2,	255
	ldi		work_timer3,	255
	ldi		work_timer4,	c_program_1_countdown

	pop		tmp1
	ret

sub_programm_1:
	push	tmp1
	subi	work_timer1,	16  ;  16  ,    )
	sbci	work_timer2,	0
	sbci	work_timer3,	0	
	sbci	work_timer4,	0
	brcc	sb_p_1_skip			;   
	inc		flag_register		;     -   
	ldi		work_timer4,	0	;  
sb_p_1_skip:
	mov		brightR,		work_timer4
	mov		brightG,		work_timer4
	mov		brightB,		work_timer4
	
	pop		tmp1
	ret

/**************************************************************************************/
/*                        2.                        */
/**************************************************************************************/
sub_programm_2_init:
	ldi		work_timer4,	0b00100011
	ldi		work_timer3,	0
	ldi		tmp1,			c_max_gradations
	mov		brightR,		tmp1
	clr		brightG
	clr		brightB
	ret
sub_programm_2:
	ldi		arg1,			5
	ldi		arg2,			0
	rcall	sub_delay

	rcall sb_p_2_changebright

	
	inc		work_timer3
	cpi		work_timer3,	c_max_gradations+1
	brne	sub_programm_2

	rcall	sb_p_2_changeprog			; maxgrad     -  
	clr		work_timer3
	ret

sb_p_2_changebright:
	/*      work_timer4*/
	/*R  - 5,	G - 3  B - 1  ( 0)*/
	
	/* */
	mov		tmp1,	work_timer4
	mov		arg1,	brightR	
	andi	tmp1,	1<<5				; 5 
	breq	sb_p_2_changebright_r_dec	;   -   
	rcall	sb_p_2_inc_bright			;   - 
	rjmp	sb_p_2_changebright_g	
sb_p_2_changebright_r_dec:
	rcall	sb_p_2_dec_bright
	/**/
sb_p_2_changebright_g:
	mov		brightR,	arg1
	
	mov		tmp1,	work_timer4
	mov		arg1,	brightG	
	andi	tmp1,	1<<3				; 5 
	breq	sb_p_2_changebright_g_dec	;   -   
	rcall	sb_p_2_inc_bright			;   - 
	rjmp	sb_p_2_changebright_b	
sb_p_2_changebright_g_dec:
	rcall	sb_p_2_dec_bright

	/**/
sb_p_2_changebright_b:
	mov		brightG,	arg1	
			
	mov		tmp1,	work_timer4
	mov		arg1,	brightB	
	andi	tmp1,	1<<1				; 5 
	breq	sb_p_2_changebright_b_dec	;   -   
	rcall	sb_p_2_inc_bright			;   - 
	rjmp	sb_p_2_changebright_end	
sb_p_2_changebright_b_dec:
	rcall	sb_p_2_dec_bright
sb_p_2_changebright_end:

	mov		brightB,	arg1
	ret

sb_p_2_changeprog:
	/*     -  6   */
	lsl		work_timer4					; 
	sbrc	work_timer4,	6			;        
	ori		work_timer4,	1			;   -    
	andi	work_timer4,	0b00111111	;   
	ret

/*  arg1*/
sb_p_2_inc_bright:
	cli
	cpi		arg1,	c_max_gradations
	breq	sb_p_2_inc_ret
	inc		arg1
sb_p_2_inc_ret:
	sei
	ret

/*  arg1*/
sb_p_2_dec_bright:
	cli
	tst		arg1			;    -  
	breq	sb_p_2_dec_ret
	dec		arg1
sb_p_2_dec_ret:
	sei	
	ret

/**************************************************************************************/
/*                  3.    	                      */
/**************************************************************************************/
sub_programm_3_init:
	ldi		work_timer4,	0b00000111
	ldi		work_timer3,	0
	ldi		tmp1,			c_max_gradations
	mov		brightR,		tmp1
	clr		brightG
	clr		brightB
	ret
sub_programm_3:
	ldi		arg1,			255
	ldi		arg2,			3
	rcall	sub_delay

	rcall sb_p_2_changebright

	
	inc		work_timer3
	cpi		work_timer3,	c_max_gradations+1
	brne	sub_programm_3

	rcall	sb_p_2_changeprog			; maxgrad     -  
	clr		work_timer3
	ret

/**************************************************************************************/
/*                        4.  			                      */
/**************************************************************************************/
sub_programm_4_init:
	ret
sub_programm_4:
	rcall	get_random
	mov		brightR,	random_number
	rcall	get_random
	mov		brightG,	random_number
	rcall	get_random
	mov		brightB,	random_number

	sbrs	brightR,	7
	clr		brightR
	sbrs	brightG,	7
	clr		brightG
	sbrs	brightB,	7
	clr		brightB

	ldi		tmp1,		0b01111111
	and		brightR,	tmp1
	and		brightG,	tmp1
	and		brightB,	tmp1

	rcall	get_random
	mov		arg2,		random_number
	clr		arg1
	rcall	sub_delay
	ret
	
/**************************************************************************************/
/*                        5. 					                      */
/**************************************************************************************/
sub_programm_5_init:
	clr		brightR
	clr		brightG
	clr		brightB
	inc		flag_register		;  
	inc		flag_register
	ret
sub_programm_5:
	sbrs	flag_register,	1	;  
	rjmp	sp_p5_main
	/* )*/
sp_p5_init_loop:
	inc		brightR
	mov		tmp1,	brightR
	lsr		tmp1
	lsr		tmp1
	mov		brightG,	tmp1

	ldi		arg1,	210
	ldi		arg2,	0
	rcall	sub_delay

	mov		tmp1,	brightR
	cpi		tmp1,	c_max_gradations
	brne	sp_p5_init_loop
	clr		flag_register
sp_p5_main:
	// 
	rcall	get_random
	mov		tmp3,		random_number	;,     R 
	lsr		tmp3
	ori		tmp3,		0b00001111		;. 
	ldi		tmp1,		255				;

/*	rcall	get_random					
	mov		tmp2,		random_number	; / 
	lsr		tmp2
	lsr		tmp2
	lsr		tmp2*/

sp_p5_main_loop:
	mov		arg1,		tmp3			;  
	rcall	sp_p5_bright_to_arg1

	ldi		arg1,		30				;   / 
	/*mov		arg2,		tmp2*/
	clr		arg2
	rcall	sub_delay

	dec		tmp1
	brne	sp_p5_main_loop				; /

	ldi		arg1,		255				;   
	rcall	get_random
	mov		tmp1,		random_number
	andi	tmp1,		0b00001111
	mov		arg2,		tmp1

	ret
//      arg1
sp_p5_bright_to_arg1:
	push	tmp1
	cp		brightR,	arg1
	breq	sp_p5_bright_to_arg1_exit
	brlo	sp_p5_bright_to_arg1_inc
	dec		brightR
	rjmp	sp_p5_bright_to_arg1_exit
sp_p5_bright_to_arg1_inc:
	inc		brightR
sp_p5_bright_to_arg1_exit:
	mov		tmp1,		brightR
	lsr		tmp1
	lsr		tmp1
	mov		brightG,	tmp1
	pop		tmp1
	ret

/*************************************************************************************/
/*                                         */
/* arg1                                                               */
/* arg2 0    , 1     */
/*************************************************************************************/
sub_get_programm_address:
	push		tmp1
	push		tmp2
	push		tmp3
	mov			tmp1,	arg1
	mov			tmp2,	arg2

	clr			tmp3

	ldi			ZL,		low(program_list*2)
	ldi			ZH,		high(program_list*2)
	lsl			tmp1							;  4,   
	lsl			tmp1							; 2 

	lsl			tmp2							;  2     

	add			tmp1,	tmp2					;   
	adc			ZL,		tmp1					;  /
	adc			ZH,		tmp3

	lpm			tmp1,	Z+						;     arg1
	lpm			tmp2,	Z						;     arg2

	movw		ZH:ZL,	tmp2:tmp1				;   Z

	pop			tmp3
	pop			tmp2
	pop			tmp1

	ret



/*************************************************************************************/
/*                                        */
/*                                                                                   */
/*************************************************************************************/
get_random:
	push	tmp1
	push	tmp2
	push	tmp3
	mov		tmp1,			random_number
	ldi		tmp2,			1
	andi	tmp1,			0b00000001

	sbrc	random_number,	2
	eor		tmp1,			tmp2
	sbrc	random_number,	3
	eor		tmp1,			tmp2
	sbrc	random_number,	4
	eor		tmp1,			tmp2

	mov		tmp3,			random_number
	lsr		tmp3
	sbrc	tmp1,			0
	subi	tmp3,			-0b10000000

	mov		random_number,	tmp3

	pop		tmp3
	pop		tmp2
	pop		tmp1
	ret

/*************************************************************************************/
/*                     Z                  */
/*************************************************************************************/
program_list: 
.dw		sub_programm_0_init, sub_programm_0
.dw		sub_programm_1_init, sub_programm_1
.dw		sub_programm_2_init, sub_programm_2
.dw		sub_programm_3_init, sub_programm_3
.dw		sub_programm_4_init, sub_programm_4
.dw		sub_programm_5_init, sub_programm_5

